<?php require_once( 'couch/cms.php' ); ?><cms:template title='Google maps' order='7'>
<cms:editable name='googlemap_instruction' type='message' order='4'>
<b>Instruction to Google Maps module</b><br><br>
Google Maps Geocoder allows to make only 2500 requests for free per day. So, we will make geocoding only in Admin panel.<br>
<b>Type</b> one address and <b>press</b> "Show coordinates", then add another if neccessary, the amount is not limited.<br>
To <b>remove</b> a marker just click on it.<br>
<b>Drag</b> map and <b>change zoom</b>, they will be automatically applied.<br>
Each marker has a number, so you can add a description to them accordingly in textarea 'Markers infoblocks', separated by '|', for example:<br><br>

&lt;div style=&quot;font-weight:bold&quot;&gt;Zero marker info&lt;/div&gt; | &lt;div style=&quot;font-style:italic&quot;&gt;First marker info&lt;/div&gt;<br><br>

<i>These infoblocks will be shown in the frontend, not on the map in Admin Area, because we need to show markers' numbers here.</i><br><br>

<b>Ajust</b> map type, controls, icon. For custom map style go to http://snazzymaps.com/ and copy a field called "Javascript style array" from this website, then past to "Map style" in Admin panel.<br><br>

<b>Save</b> the template.
</cms:editable>
<cms:editable name='googlemap' type='message' order='5'>
<script src="https://maps.googleapis.com/maps/api/js?v=3.exp"></script>
<script>

// Define variables async (globally)

var goo = google.maps, 
		geocoder = new goo.Geocoder(),
		map,
		centerInput,
		zoomInput,
		encodedInput,
		mapContainer,
		mapOptions,
		markersArray = [];

function initialize() {

	// Define global variables on window is loaded
	
	centerInput = document.getElementById('f_googlemap_center');
	zoomInput = document.getElementById('f_googlemap_zoom');
	encodedInput = document.getElementById('f_googlemap_encoded');
	mapContainer = document.getElementById('map-canvas');
	
	// Check if the inputs are filled
	
	centerInput.value = centerInput.value ? centerInput.value : '(55, 37)';
	zoomInput.value = zoomInput.value ? zoomInput.value : '2';


	// Make the map
	
	mapOptions = {zoom: parseFloat(zoomInput.value), center: makeLatLng(centerInput.value), disableDefaultUI:true};
	map = new goo.Map(mapContainer, mapOptions);
	makeMarkers(encodedInput);

	// Change values on zoom and change map center
	
	goo.event.addListener(map, 'dragend', function() {centerInput.value = map.getCenter()});
	goo.event.addListener(map, 'zoom_changed', function() {zoomInput.value = map.getZoom()});

}

// Function to make LatLng from String

function makeLatLng(theString) {
	var stringValue = theString,
			stringValueComma = stringValue.indexOf(','),
			stringValueLat = parseFloat(stringValue.substring(1, stringValueComma)),
			stringValueLong = parseFloat(stringValue.substring(stringValueComma + 1, stringValue.length));
	return new goo.LatLng(stringValueLat, stringValueLong);
}

// Function to check existence of the markers and position them
	
function makeMarkers(input) {
	var markersArrayOld = input.value ? input.value.split("|") : [];
  for (var i = 0; i < markersArray.length; i++ ) {markersArray[i].setMap(null)};
  markersArray.length = 0;
	for	(i = 0; i < markersArrayOld.length; i++) {
		var marker = new goo.Marker({map: map, position: makeLatLng(markersArrayOld[i])});
		attachSecretMessage(marker, i);
		markersArray.push(marker);
	}
}

// Function to add a number and Click events for markers

function attachSecretMessage(marker, i) {
	var infowindow = new goo.InfoWindow({content: i.toString()});
	infowindow.open(marker.get('map'), marker);
  goo.event.addListener(marker, 'click', function() {
		var allMarkers = document.getElementById('f_googlemap_encoded').value.split("|");
		var clickedMarker = marker.position;
		for	(i = 0; i < allMarkers.length; i++) {(allMarkers[i] == clickedMarker ? allMarkers.splice(i, 1) : allMarkers[i])}
		marker.setMap(null);
		document.getElementById('f_googlemap_encoded').value = allMarkers.join("|")
  });
}

// Function to convert Geolocation to String (to overcome Google's '2500 requests' limitation)

function codeAddress() {
  var address = document.getElementById('addressGeocode').value,
			addressEncoded = document.getElementById('f_googlemap_encoded');
  geocoder.geocode({'address': address}, function(results, status) {
    if (status == goo.GeocoderStatus.OK) {
			addressEncoded.value = (addressEncoded.value ? addressEncoded.value + '|' + results[0].geometry.location : results[0].geometry.location);
			makeMarkers(addressEncoded);
    } else {alert('Geocode error: ' + status)}
  });
}

goo.event.addDomListener(window, 'load', initialize);
</script>
<div style="position: absolute;top: 5px;left: 50%;margin-left: -180px;z-index: 5;background-color: #fff;padding: 5px;border: 1px solid #999;">
	<input id="addressGeocode" type="textbox" value="" placeholder="Type address">
	<input type="button" value="Show coordinates" onclick="codeAddress()">
</div>
<div id="map-canvas" style="height: 300px"></div>
</cms:editable>
<cms:editable name='googlemap_encoded' type='text' label='Geocoded address' order='5' />
<cms:editable name='googlemap_center' type='text' label='Map center' order='5' />
<cms:editable name='googlemap_zoom' type='text' label='Zoom level' order='6' />
<cms:editable name='googlemap_message' type='textarea' height='100' label='Markers infoblocks' no_xss_check='1' order='6' />
<cms:editable name='googlemap_type' type='dropdown' label='Map type' opt_values='Hybrid=HYBRID|Roadmap=ROADMAP|Satellite=SATELLITE|Terrain=TERRAIN' order='6' />
<cms:editable name='googlemap_elements' type='checkbox' label='Map controls' opt_values='Pan=panControl|Zoom=zoomControl|Scale=scaleControl|Map type=mapTypeControl|Street View=streetViewControl' order='6' />
<cms:editable name='googlemap_style' type='textarea' height='50' label='Map style' desc='works only with type "Roadmap"' no_xss_check='1' order='6' />
<cms:editable name='googlemap_icon' label='Icon' desc='applies to all markers' quality='100' show_preview='1' preview_width='100' type='image' order='6' />
</cms:template>
<cms:embed 'googlemaps_snippet.php'/>
<?php COUCH::invoke(); ?>